<?php

namespace App\Http\Controllers\API\Diocese;

use App\Http\Controllers\Controller;
use App\Models\BookStore;
use Illuminate\Http\Request;

class BookStoreController extends Controller
{
    public function books(){
        $books = BookStore::where('status', '1')->get();
        $response = collect($books)->map(function ($bookItem) {
          
            return [
                'id' => $bookItem->id,
                'book_title' =>$bookItem->book_name,
                'author' => $bookItem->author_name,
                'cover_image' => $bookItem->image ? asset('uploads/events/' . $bookItem->image) : null,
                'actual_price' => $bookItem->actual_price,
                'seller_price' => $bookItem->seller_price,
                'discount' => $bookItem->discount ? $bookItem->discount : null
             

            ];
        });
        if(!empty($response)){
            return response()->json(
                array(
                    'status' => True,
                    'data' => $response
                ),
                200
            );
        }
      else{
        return response()->json(
            array(
                'status' => False,
                'error' => "Something went wrong"
            ),
            422
        );
      }
    }

    public function book(string $id){
        $books = BookStore::where('id',$id)->where('status', '1')->get();
        $response = collect($books)->map(function ($bookItem) {
          
            return [
                'id' => $bookItem->id,
                'cover_image' => $bookItem->image ? asset('uploads/events/' . $bookItem->image) : null,
                'book_title' =>$bookItem->book_name,
                'author' => $bookItem->author_name,
                'about_book' =>$bookItem->about_book,
                'actual_price' => $bookItem->actual_price,
                'seller_price' => $bookItem->seller_price,
                'discount' => $bookItem->discount ? $bookItem->discount : null
             

            ];
        });
        if(!empty($response)){
            return response()->json(
                array(
                    'status' => True,
                    'data' => $response
                ),
                200
            );
        }
      else{
        return response()->json(
            array(
                'status' => False,
                'error' => "Something went wrong"
            ),
            422
        );
      }
    }
}
