<?php

namespace App\Http\Controllers\API\Feeback;

use App\Http\Controllers\Controller;
use App\Models\Feedback;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class FeedbackController extends Controller
{
    public function store(Request $request){
        $validator = Validator::make($request->all(),[
         'email' => 'required',
         'content' => 'required',
         
         
        ]);
if($validator->fails()){
 return response()->json([
     'status' => 400,
     'errors' => $validator->messages(),
 ]);
}else{
 $data = $request->all();
 $feedback = new Feedback();
 $feedback->email = $data['email'];
 $feedback->content = $data['content'];
 $feedback->sender = $data['sender'];
 $feedback->receiver = "admin";
 $feedback->replay_id = $data['replay_id'] ?? null;
 $feedback->save();
 return response()->json([
     'status' => 200,
     'message' => 'Feedback send successfully',
 ]);
 }
}

public function send_feedback(Request $request){
    $validator = Validator::make($request->all(),[
        'email' => 'required',
        'content' => 'required',
        
       
       ]);
       if($validator->fails()){
        return response()->json([
            'status' => 400,
            'errors' => $validator->messages(),
        ]);
    }
    $feedback = new Feedback();
    $feedback->email = $request->email;
    $feedback->content = $request->content;
    $feedback->sender = $request->sender;
   
    $feedback->replay_id = $request->replay_id;
    $feedback->save();
    return response()->json([
        'status' => 200,
        'message' => 'Feedback send successfully',
    ]);
}



public function getFeedback(Request $request){
    $email = $request->email;
    $feedback = Feedback::where('sender',$email)->orWhere('receiver',$email)->orderBy('id', 'Desc')->take(15)->get();
    $response = collect($feedback)->map(function ($FeedbackItem) {
          
        return [
            'id' => $FeedbackItem->id,
            'email' => $FeedbackItem->email,
            'content' => $FeedbackItem->content,
            'replay_id' => $FeedbackItem->replay_id,
            'sender' => $FeedbackItem->sender,
            'receiver' => $FeedbackItem->receiver,
            'read' => $FeedbackItem->read,
            'status' => $FeedbackItem->status,
           

        ];
    });
    if(!empty($response)){
        return response()->json(
            array(
                'status' => True,
                'data' => $response
            ),
            200
        );
    }
  else{
    return response()->json(
        array(
            'status' => False,
            'error' => "Something went wrong"
        ),
        422
    );
  }
}
}