<?php

namespace App\Http\Controllers\API\Metropolitan;

use App\Http\Controllers\Controller;
use App\Models\Posts;
use Carbon\Carbon;
use Illuminate\Http\Request;

class PostController extends Controller
{
    public function latest_post(){
        $posts = Posts::where('status', '1')->orderBy('id', 'Desc')->take(15)->get();
       
        $response = collect($posts)->map(function ($PostItem) {
          
            return [
                'id' => $PostItem->id,
                'image' => $PostItem->image ? asset('uploads/posts/' . $PostItem->image) : null,
                'post_name' => $PostItem->post_title,
                'post' => $PostItem->post_description,
                'post_date' =>Carbon::parse($PostItem->created_at)->format('j M Y'),
                'to_time' => Carbon::parse($PostItem->created_at)->format('g:i A'),
                

            ];
        });
        if(!empty($response)){
            return response()->json(
                array(
                    'status' => True,
                    'data' => $response
                ),
                200
            );
        }
      else{
        return response()->json(
            array(
                'status' => False,
                'error' => "Something went wrong"
            ),
            422
        );
      }
    }

    public function post( string $id){
        $posts = Posts::where('id', $id)->where('status', '1')->orderBy('id', 'Desc')->get();
       
        $response = collect($posts)->map(function ($PostItem) {
          
            return [
                'id' => $PostItem->id,
                'image' => $PostItem->image ? asset('uploads/posts/' . $PostItem->image) : null,
                'post_name' => $PostItem->post_title,
                'post' => $PostItem->post_description,
                'post_date' =>Carbon::parse($PostItem->created_at)->format('j M Y'),
                'to_time' => Carbon::parse($PostItem->created_at)->format('g:i A'),
                

            ];
        });
        if(!empty($response)){
            return response()->json(
                array(
                    'status' => True,
                    'data' => $response
                ),
                200
            );
        }
      else{
        return response()->json(
            array(
                'status' => False,
                'error' => "Something went wrong"
            ),
            422
        );
      }
    }


}
