<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\ChurchLocator;
use App\Models\Presit;
use Illuminate\Http\Request;

class PresitDirectoryController extends Controller
{
    public function presit(){
        $presit = Presit::where('status', '1')->orderBy('id', 'Desc')->get();
       
        $response = collect($presit)->map(function ($PresitItem) {
          
            return [
                'id' => $PresitItem->id,
                'image' => $PresitItem->image ? asset('uploads/presit/' . $PresitItem->image) : null,
                'Presit_name' => $PresitItem->name,
                 'church' => $PresitItem->current_chruch,
                 'role' =>$PresitItem->current_role,
                 'contact_no' => $PresitItem->phone
            ];
        });
        if(!empty($response)){
            return response()->json(
                array(
                    'status' => True,
                    'data' => $response
                ),
                200
            );
        }
      else{
        return response()->json(
            array(
                'status' => False,
                'error' => "Something went wrong"
            ),
            422
        );
      }
    }
    public function churches(){
        $church = ChurchLocator::where('status', '1')->orderBy('id', 'Desc')->get();
        
        if ($church->isEmpty()) {
            return response()->json([
                'status' => false,
                'error' => 'No Churches found',
            ], 422);
        }
        $response = collect($church)->map(function ($ChurchItem) {
            $image = $ChurchItem->churchgallery->where('is_featured_image', 1)->first();
        
            return [
                'id' => $ChurchItem->id,
                'church_image' => $image ? asset('uploads/churches/' . $image->image) : null,
                'church_name' => $ChurchItem->name,
                'about_church' =>$ChurchItem->about_church,
                'address' => $ChurchItem->address,
                'phone' => $ChurchItem->phone,
            ];
        });
        if(!empty($response)){
            return response()->json(
                array(
                    'status' => True,
                    'data' => $response
                ),
                200
            );
        }
      else{
        return response()->json(
            array(
                'status' => False,
                'error' => "Something went wrong"
            ),
            422
        );
      }
    }



      public function church(string $id){
        $church = ChurchLocator::where('id', $id)->where('status', '1')->get();
       
        if ($church->isEmpty()) {
            return response()->json([
                'status' => false,
                'error' => 'No Church found',
            ], 422);
        }
        $response = collect($church)->map(function ($ChurchItem) {
            $image = $ChurchItem->churchgallery->where('is_featured_image', 1)->first();
            $gallery = $ChurchItem->churchgallery;
             
            return [
                'id' => $ChurchItem->id,
                'church_image' => $image ? asset('uploads/churches/' . $image->image) : null,
                'church_name' => $ChurchItem->name,
                'about_church' => $ChurchItem->about_church,
                'address' => $ChurchItem->address,
                'phone' => $ChurchItem->phone,
                'images' => collect($gallery)->map(function ($galleryItem) {
                        // return [
                        //     'galleryid' => $galleryItem->id,
                        //     'url' => asset('uploads/news/') .'/'. $galleryItem->image,
                        // ];
                        return asset('uploads/churches/') .'/'. $galleryItem->image;
                    }),
                
            ];
        });
        if(!empty($response)){
            return response()->json(
                array(
                    'status' => True,
                    'data' => $response
                ),
                200
            );
        }
      else{
        return response()->json(
            array(
                'status' => False,
                'error' => "Something went wrong"
            ),
            422
        );
      }
    }
    




}
