<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\SpiritualWings;
use Illuminate\Http\Request;

class SpiritualWingsController extends Controller
{
    public function spiritual_wings(){
        // $spiritual = SpiritualWings::where('status', '1')
        // ->orderBy('id', 'desc')
        // ->pluck('title', 'id');
        // $response = collect($spiritual)->map(function ($SpiritualItem) {
          
        //     return [
        //         'id' => $SpiritualItem->id,
        //         'title' => $SpiritualItem->title,
        //      ];
        // });
         $response = SpiritualWings::where('status', '1')
    ->orderByDesc('id')
    ->pluck('title', 'id')
    ->map(function ($title, $id) {
        return compact('id', 'title');
    });
        if(!empty($response)){
            return response()->json(
                array(
                    'status' => True,
                    'data' => $response
                ),
                200
            );
        }
      else{
        return response()->json(
            array(
                'status' => False,
                'error' => "Something went wrong"
            ),
            422
        );
      }


    }

    public function get_spiritual_wings(string $id){
        $spiritual = SpiritualWings::where('id', $id)->where('status', '1')->get();
       
        if ($spiritual->isEmpty()) {
            return response()->json([
                'status' => false,
                'error' => 'No Spiritual Wings found',
            ], 422);
        }
        $response = collect($spiritual)->map(function ($SpiritualItem) {
            $image = $SpiritualItem->spiritualgallery->first();
            $gallery = $SpiritualItem->spiritualgallery;
            $bearer = $SpiritualItem->officebearer;
             
            return [
                'id' => $SpiritualItem->id,
                'main-image' => $image ? asset('uploads/spiritual-wings/' . $image->image) : null,
                'title' => $SpiritualItem->title,
                'sub-title' => $SpiritualItem->sub_title,
                'about' => $SpiritualItem->about,
                'images' => collect($gallery)->map(function ($galleryItem) {
                        // return [
                        //     'galleryid' => $galleryItem->id,
                        //     'url' => asset('uploads/news/') .'/'. $galleryItem->image,
                        // ];
                        return asset('uploads/spiritual-wings/') .'/'. $galleryItem->image;
                    }),
               'office-bearers' => collect($bearer)->map(function($bearerItem){
                  return [
                    'bearer_id' => $bearerItem->id,
                    'designation' => $bearerItem->designation,
                    'image' => $bearerItem->image ? asset('uploads/spiritual-wings/' . $bearerItem->image) : null,
                    'contact_number' => $bearerItem->phone

                  ];
               })
                
            ];
        });
        if(!empty($response)){
            return response()->json(
                array(
                    'status' => True,
                    'data' => $response
                ),
                200
            );
        }
      else{
        return response()->json(
            array(
                'status' => False,
                'error' => "Something went wrong"
            ),
            422
        );
      } 
}

}