<?php

namespace App\Http\Controllers\Admin\Auth;

use App\Http\Controllers\Controller;
use App\Mail\ForgotPasswordMail;
use App\Models\Admin;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Str;

class ForgotPasswordController extends Controller
{
    public function index(){
        return view('admin.auth.forgot-password');
    }
    
    public function submitForgetPasswordForm(Request $request)
    {
        $request->validate([
            // 'email' => 'required|email|exists:Admins',
            'email' => 'required',
        ]);

        $token = Str::random(64);

        DB::table('password_reset_tokens')->insert([
            'email' => $request->email,
            'token' => $token,
            'created_at' => Carbon::now()
        ]);
        $email = $request->email;
        Mail::send('admin.email.forget-password', ['token' => $token], function ($message) use ($email) {
            $message->to($email)
                ->subject('Reset Admin Password In Avosys');
        });
        // try {
        //     // Replace with the user's email address
        //     $details = [
        //         'token' => $token, // Replace with the actual token
        //         // Add any other necessary details for your email content
        //     ];
        
        //     // Send the email using the Mailable
        //     Mail::to($email)->send(new ForgotPasswordMail($details));
        
        //     return 'Forgot password email sent successfully!';
        // } catch (\Exception $e) {
        //     return 'Failed to send forgot password email: ' . $e->getMessage();
        // }

        return back()->with('message', 'We have e-mailed your password reset link!');
    }
    /**
     * Write code on Method
     *
     * @return response()
     */
    public function showResetPasswordForm($token)
    {
        $email = DB::table('password_reset_tokens')->where('token', $token)->first('email');
        return view('admin.auth.forgetPasswordLink', ['token' => $token, 'email' => $email->email]);
    }

    /**
     * Write code on Method
     *
     * @return response()
     */
    public function submitResetPasswordForm(Request $request)
    {
        $request->validate([
           
            'email' => 'required',
            'password' => 'required|string|min:6|confirmed',
            'password_confirmation' => 'required'
        ]);

        $updatePassword = DB::table('password_reset_tokens')
            ->where([
                'email' => $request->email,
                'token' => $request->token
            ])
            ->first();

        if (!$updatePassword) {
            return back()->withInput()->with('error', 'Invalid token!');
        }
        $user =   Admin::where('id', 1)
            ->update([
                'password' => Hash::make($request->password)
            ]);
        // $user = Admin::where('email', $request->email)
        //     ->update(['password' => Hash::make($request->password)]);

        DB::table('password_reset_tokens')->where(['email' => $request->email])->delete();

        return redirect(route('admin.login'))->with('message', 'Your password has been changed!');
    }
}
