<?php

namespace App\Http\Controllers\Admin\Auth;

use App\Http\Controllers\Controller;
use App\Models\Admin;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\Validator;

class LoginController extends Controller
{
    //

    public  function index(){
        return view('admin.auth.login');
    }
    public function login(Request $request){
        $credentials = $this->validate($request, [
            'email' => 'required|email',
            'password' => 'required',
        ]);
      
        if(Auth::guard('admins')->attempt($credentials)){
            $res =   Admin::where('email', $request->email)
            ->update([
                'last_logged_in' => now()
            ]);
        $user = auth()->guard('admins')->user();
        Session::put('user', $user);
        if ($user->is_admin == 1) {
            return redirect()->route('admin.dashboard')->with('success', 'You are Logged in sucessfully.');
        }
    } else {
        return back()->with('error', 'Whoops! invalid email and password.');
    }
            return redirect()->route('admin.login');
        }
    

        public function logout(){
            Auth::guard('admins')->logout();
            return redirect()->route('admin.login');
        }

        public function changePassword(){
            return view('admin.auth.change-password');
        }
        public function updatePassword(Request $request){
            $validator = Validator::make($request->all(), [
                'password' => 'required|string|min:8',
                'confirm_password' => 'required|string|min:8|same:password',
            ]);
    
            if ($validator->fails()) {
                $errors = $validator->errors();
                return redirect()->back()->withErrors($errors);
            }
            $newPassword= Hash::make($request->password);
           $res =Admin::where('id', Auth::guard('admins')->user()->id)->update(['password' => $newPassword]);

            if ($res == 1) {
                return back()->with('success', "Password updated Successfully");
            } else {
                return back()->with('error', "Something Wrong");
            }


        }


        
    

    

   
}
